Name:           waf
Version:        2.0.27
Release:    1%{?dist}
Summary:        A Python-based build system
License:        BSD and Python
URL:            https://waf.io/
Source0:         waf-%{version}.stripped.tar.bz2
Source1:        unpack_wafdir.py
Patch0:         waf-2.0.18-libdir.patch
Patch1:         waf-2.0.18-logo.patch
Patch2:         waf-2.0.18-sphinx-no-W.patch

%bcond_without docs

BuildArch:      noarch
BuildRequires:  python3-devel
%if %{with docs}
BuildRequires:  python3-sphinx
BuildRequires:  graphviz
BuildRequires:  ImageMagick
%endif # with docs

Provides:       %{name}-python3 = %{version}-%{release}

%if "%{?python3_version}" != ""
Requires:       python(abi) = %{python3_version}
%endif

%global __requires_exclude_from ^%{_docdir}/.*$
%global __provides_exclude_from ^%{_docdir}/.*$

%global _description %{expand:
Waf is a Python-based framework for configuring, compiling and
installing applications. It is a replacement for other tools such as
Autotools, Scons, CMake or Ant.}

%description %_description


%if %{with docs}
%package -n %{name}-doc
Summary:        Documentation for %{name}
Requires:       %{name} = %{version}-%{release}

%description -n %{name}-doc %_description

This package contains the HTML documentation for %{name}.
%endif # with docs


%prep
%autosetup -p1


%build
extras=
for f in waflib/extras/*.py ; do
  f=$(basename "$f" .py);
  if [ "$f" != "__init__" ]; then
    extras="${extras:+$extras,}$f" ;
  fi
done
%{__python3} ./waf-light --make-waf --strip --tools="$extras"

%if %{with docs}
export WAFDIR=$(pwd)
pushd docs/sphinx
%{__python3} ../../waf -v configure build
popd
%endif # with docs


%install
%{__python3} %{S:1} _temp
pushd _temp
find . -name '*.py' -printf '%%P\0' |
  xargs -0 -I{} install -m 0644 -p -D {} %{buildroot}%{_datadir}/waf3/{}
popd

install -m 0755 -p -D waf-light %{buildroot}%{_bindir}/waf
ln -s waf %{buildroot}%{_bindir}/waf-3
ln -s waf %{buildroot}%{_bindir}/waf-%{python3_version}

find %{buildroot}%{_datadir}/ -name '*.py' \
     -exec sed -i -e '1{/^#!/d}' -e 's|\r$||g' {} \;

sed -i "1c#! %{__python3}" %{buildroot}%{_bindir}/waf

find demos utils -type f -exec chmod 0644 {} \;

find demos \( -name '*.py' -o -name '*.py.in' -o -name 'wscript' -o -name 'wscript_build' \) \
  -exec sed -e '1{/^#!/d}' -e '1i#!%{__python3}' -i {} \;

rm -f docs/sphinx/build/html/.buildinfo

%py_byte_compile %{__python3} %{buildroot}%{_datadir}/waf3


%files
%doc README.md ChangeLog demos
%{_bindir}/waf-%{python3_version}
%{_bindir}/waf-3
%{_bindir}/waf
%{_datadir}/waf3


%if %{with docs}
%files -n %{name}-doc
%doc docs/sphinx/build/html
%endif # with docs


%changelog
* Mon Jul 15 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 2.0.27-1
- initial build
